

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Derived KEK TISCI Description &mdash; TISCI User Guide</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  
    <link rel="stylesheet" href="../../_static/theme_overrides.css" type="text/css" />
  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="TISCI User Guide" href="../../index.html"/>
        <link rel="up" title="Chapter 2: TISCI Message Documentation" href="../index.html"/>
        <link rel="next" title="Derived SMEK TISCI Description" href="dsmek_management.html"/>
        <link rel="prev" title="Extended OTP TISCI Description" href="extended_otp.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">
  <header id="tiHeader">
    <div class="top">
      <ul>
        <li id="top_logo">
          <a href="http://www.ti.com">
            <img src="../../_static/img/ti_logo.png"/>
          </a>
        </li>
      </ul>
    </div>
    <div class="nav"></div>
  </header>
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> TISCI
          

          
          </a>

          
            
            
              <div class="version">
                11.00.04
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../1_intro/index.html">Chapter 1: Introduction</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Chapter 2: TISCI Message Documentation</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../general/TISCI_header.html">Texas Instruments System Controller Interface (TISCI)</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#general">General</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#power-management-pm">Power Management (PM)</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#resource-management-rm">Resource Management (RM)</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../index.html#secure-management">Secure Management</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="sec_cert_format.html">Security X509 Certificate Documentation</a></li>
<li class="toctree-l3"><a class="reference internal" href="PROC_BOOT.html">Processor Boot Management TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="firewall_api.html">Firewall TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="sec_ap_data_transfer.html">Secure AP Command Interface</a></li>
<li class="toctree-l3"><a class="reference internal" href="runtime_debug.html">Runtime Debug TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="extended_otp.html">Extended OTP TISCI Description</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Derived KEK TISCI Description</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#api-description">API Description</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="dsmek_management.html">Derived SMEK TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="security_handover.html">Security Handover Message Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="keywriter.html">OTP Keywriter TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="otp_revision.html">OTP Revision Read/Write Message Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="keyring.html">KEYRING TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="csp.html">Cryto Service TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="fwl_safety_core.html">FIREWALL READ ACCESS SAFETY CORE TISCI Description</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../3_boardcfg/index.html">Chapter 3: Board Configuration</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../4_trace/index.html">Chapter 4: Interpreting Trace Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../5_soc_doc/index.html">Chapter 5: SoC Family Specific Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../6_topic_user_guides/index.html">Chapter 6: Topic User Guides</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../index.html">TISCI</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../index.html">Chapter 2: TISCI Message Documentation</a> &raquo;</li>
      
    <li>Derived KEK TISCI Description</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="derived-kek-tisci-description">
<h1>Derived KEK TISCI Description<a class="headerlink" href="#derived-kek-tisci-description" title="Permalink to this headline">¶</a></h1>
<p id="sec-dkek-tisci-desc">This chapter provides information on  System Firmware API for Derived Key Encryption
Key(DKEK) management. The available API are listed below.</p>
<table border="1" class="docutils">
<colgroup>
<col width="12%" />
<col width="46%" />
<col width="11%" />
<col width="13%" />
<col width="19%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">TISCI Message ID</th>
<th class="head">Message Name</th>
<th class="head">Available in GP</th>
<th class="head">Avialable in HS-FS</th>
<th class="head">Previous Message Name</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>0x9003</td>
<td><a class="reference internal" href="#sec-api-sa2ul-set-dkek"><span class="std std-ref">TISCI_MSG_CRYPTO_SET_DKEK</span></a></td>
<td>Yes*</td>
<td>Yes</td>
<td>TISCI_MSG_SA2UL_SET_DKEK</td>
</tr>
<tr class="row-odd"><td>0x9004</td>
<td><a class="reference internal" href="#sec-api-sa2ul-release-dkek"><span class="std std-ref">TISCI_MSG_CRYPTO_RELEASE_DKEK</span></a></td>
<td>Yes*</td>
<td>Yes</td>
<td>TISCI_MSG_SA2UL_RELEASE_DKEK</td>
</tr>
<tr class="row-even"><td>0x9029</td>
<td><a class="reference internal" href="#sec-api-sa2ul-get-dkek"><span class="std std-ref">TISCI_MSG_CRYPTO_GET_DKEK</span></a></td>
<td>Yes*</td>
<td>Yes</td>
<td>TISCI_MSG_SA2UL_GET_DKEK</td>
</tr>
</tbody>
</table>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p>The TISCI Message ID macros have been renamed. Please update your code to use the new names.</p>
<p class="last">On GP devices, DKEK APIs return unconditional success but do not actually
involve any step to derive or program the DKEK values</p>
</div>
<p>This document must be read along side</p>
<ol class="arabic simple">
<li><a class="reference internal" href="../../6_topic_user_guides/dkek_management.html"><span class="doc">Using Derived KEK on HS devices</span></a> and</li>
<li><a class="reference internal" href="../../3_boardcfg/BOARDCFG_SEC.html"><span class="doc">Security Board Configuration</span></a>, specifically <a class="reference internal" href="../../3_boardcfg/BOARDCFG_SEC.html#pub-boardcfg-dkek-config"><span class="std std-ref">Derived KEK Management</span></a></li>
</ol>
<div class="section" id="api-description">
<h2>API Description<a class="headerlink" href="#api-description" title="Permalink to this headline">¶</a></h2>
<div class="section" id="tisci-msg-crypto-set-dkek-set-dkek">
<span id="sec-api-sa2ul-set-dkek"></span><h3>TISCI_MSG_CRYPTO_SET_DKEK - Set DKEK<a class="headerlink" href="#tisci-msg-crypto-set-dkek-set-dkek" title="Permalink to this headline">¶</a></h3>
<p><strong>Usage</strong>:</p>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Normal</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>Yes</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="tisci-message-id">
<h3>TISCI Message ID<a class="headerlink" href="#tisci-message-id" title="Permalink to this headline">¶</a></h3>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_CRYPTO_SET_DKEK</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x9003U)</span></code></p>
<p>Message to derive a KEK and set DKEK register</p>
</p>
<p><p><strong>struct tisci_msg_crypto_set_dkek_req</strong></p>
<p>TISCI Request for setting DKEK in crypto engine registers</p>
<table border="1" class="docutils">
<colgroup>
<col width="13%" />
<col width="12%" />
<col width="75%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header.</td>
</tr>
<tr class="row-odd"><td>instance</td>
<td>u8</td>
<td>crypto engine instance number - set to 0</td>
</tr>
<tr class="row-even"><td>kdf_label_len</td>
<td>u8</td>
<td>Length of “Label” input to KDF</td>
</tr>
<tr class="row-odd"><td>kdf_context_len</td>
<td>u8</td>
<td>Length of “Context” input to KDF</td>
</tr>
<tr class="row-even"><td>kdf_label_and_context</td>
<td>u8</td>
<td>”Label” and “Context” bytes are stored in this array one after another. Maximum length of this field is KDF_LABEL_AND_CONTEXT_LEN_MAX</td>
</tr>
</tbody>
</table>
</p>
<p><p><strong>struct tisci_msg_crypto_set_dkek_resp</strong></p>
<p>TISCI Response for setting DKEK in crypto engine registers</p>
<table border="1" class="docutils">
<colgroup>
<col width="20%" />
<col width="32%" />
<col width="48%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header.</td>
</tr>
</tbody>
</table>
</p>
<p><code class="docutils literal"><span class="pre">KDF_LABEL_AND_CONTEXT_LEN_MAX</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">41U</span></code></p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The structures <code class="docutils literal"><span class="pre">tisci_msg_sa2ul_set_dkek_req</span></code> and <code class="docutils literal"><span class="pre">tisci_msg_sa2ul_set_dkek_resp</span></code> have been renamed to <code class="docutils literal"><span class="pre">tisci_msg_crypto_set_dkek_req</span></code> and <code class="docutils literal"><span class="pre">tisci_msg_crypto_set_dkek_resp</span></code> respectively.
Please update your code to use the new names.</p>
</div>
<p>See <a class="reference internal" href="#pub-tisci-dkek-notes"><span class="std std-ref">API Notes</span></a> below.</p>
</div>
<div class="section" id="tisci-msg-crypto-release-dkek-release-dkek">
<span id="sec-api-sa2ul-release-dkek"></span><h3>TISCI_MSG_CRYPTO_RELEASE_DKEK - Release DKEK<a class="headerlink" href="#tisci-msg-crypto-release-dkek-release-dkek" title="Permalink to this headline">¶</a></h3>
<p><strong>Usage</strong>:</p>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Normal</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>Yes</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id1">
<h3>TISCI Message ID<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h3>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_CRYPTO_RELEASE_DKEK</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x9004U)</span></code></p>
<p>Message to erase the DKEK register</p>
</p>
<p><p><strong>struct tisci_msg_crypto_release_dkek_req</strong></p>
<p>TISCI Request for releasing DKEK</p>
<table border="1" class="docutils">
<colgroup>
<col width="19%" />
<col width="30%" />
<col width="51%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header.</td>
</tr>
<tr class="row-odd"><td>instance</td>
<td>u8</td>
<td>Crypto instance number - set to 0</td>
</tr>
</tbody>
</table>
</p>
<p><p><strong>struct tisci_msg_crypto_release_dkek_resp</strong></p>
<p>TISCI Response for Releasing DKEK</p>
<table border="1" class="docutils">
<colgroup>
<col width="20%" />
<col width="32%" />
<col width="48%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header.</td>
</tr>
</tbody>
</table>
</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The structures <code class="docutils literal"><span class="pre">tisci_msg_sa2ul_release_dkek_req</span></code> and <code class="docutils literal"><span class="pre">tisci_msg_sa2ul_release_dkek_resp</span></code> have been renamed to <code class="docutils literal"><span class="pre">tisci_msg_crypto_release_dkek_req</span></code> and <code class="docutils literal"><span class="pre">tisci_msg_crypto_release_dkek_resp</span></code> respectively.
Please update your code to use the new names.</p>
</div>
<p>See <a class="reference internal" href="#pub-tisci-dkek-notes"><span class="std std-ref">API Notes</span></a> below.</p>
</div>
<div class="section" id="tisci-msg-crypto-get-dkek-get-dkek">
<span id="sec-api-sa2ul-get-dkek"></span><h3>TISCI_MSG_CRYPTO_GET_DKEK - Get DKEK<a class="headerlink" href="#tisci-msg-crypto-get-dkek-get-dkek" title="Permalink to this headline">¶</a></h3>
<p><strong>Usage</strong>:</p>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Normal</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>Yes</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id2">
<h3>TISCI Message ID<a class="headerlink" href="#id2" title="Permalink to this headline">¶</a></h3>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_CRYPTO_GET_DKEK</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x9029U)</span></code></p>
<p>Message to derive a KEK and return it via TISCI</p>
</p>
<p><code class="docutils literal"><span class="pre">CRYPTO_DKEK_KEY_LEN</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(32U)</span></code></p>
<p><p><strong>struct tisci_msg_crypto_get_dkek_req</strong></p>
<p>TISCI Request for getting DKEK via TISCI</p>
<table border="1" class="docutils">
<colgroup>
<col width="13%" />
<col width="12%" />
<col width="75%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header.</td>
</tr>
<tr class="row-odd"><td>instance</td>
<td>u8</td>
<td>Crypto engine instance number - set to 0</td>
</tr>
<tr class="row-even"><td>kdf_label_len</td>
<td>u8</td>
<td>Length of “Label” input to KDF</td>
</tr>
<tr class="row-odd"><td>kdf_context_len</td>
<td>u8</td>
<td>Length of “Context” input to KDF</td>
</tr>
<tr class="row-even"><td>kdf_label_and_context</td>
<td>u8</td>
<td>”Label” and “Context” bytes are stored in this array one after another. Maximum length of this field is KDF_LABEL_AND_CONTEXT_LEN_MAX</td>
</tr>
</tbody>
</table>
</p>
<p><p><strong>struct tisci_msg_crypto_get_dkek_resp</strong></p>
<p>TISCI Response for requesting DKEK</p>
<table border="1" class="docutils">
<colgroup>
<col width="15%" />
<col width="25%" />
<col width="60%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header.</td>
</tr>
<tr class="row-odd"><td>dkek</td>
<td>u8</td>
<td>Array containing Derived KEK. Length is 32 bytes</td>
</tr>
</tbody>
</table>
</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The structures <code class="docutils literal"><span class="pre">tisci_msg_sa2ul_get_dkek_req</span></code> and <code class="docutils literal"><span class="pre">tisci_msg_sa2ul_get_dkek_resp</span></code> have been renamed to <code class="docutils literal"><span class="pre">tisci_msg_crypto_get_dkek_req</span></code> and <code class="docutils literal"><span class="pre">tisci_msg_crypto_get_dkek_resp</span></code> respectively.
Also, the MACRO <code class="docutils literal"><span class="pre">SA2UL_DKEK_KEY_LEN</span></code> has been renamed to <code class="docutils literal"><span class="pre">CRYPTO_DKEK_KEY_LEN</span></code>.
Please update your code to use the new names.</p>
</div>
<p>See <a class="reference internal" href="#pub-tisci-dkek-notes"><span class="std std-ref">API Notes</span></a> below.</p>
</div>
<div class="section" id="api-notes">
<span id="pub-tisci-dkek-notes"></span><h3>API Notes<a class="headerlink" href="#api-notes" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li>The total length of the Label and Context fields below is limited by the size
of the TISCI messages(see <a class="reference internal" href="../general/TISCI_header.html#pub-secure-msg-header"><span class="std std-ref">Secure Messaging Header</span></a>) to 41 bytes.</li>
<li>System Firmware only support <code class="docutils literal"><span class="pre">instance</span></code> value of 0 in the API below.</li>
</ul>
</div>
</div>
</div>


           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="dsmek_management.html" class="btn btn-neutral float-right" title="Derived SMEK TISCI Description" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="extended_otp.html" class="btn btn-neutral" title="Extended OTP TISCI Description" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
      <a href="http://www.ti.com/corp/docs/legal/copyright.shtml">&copy; Copyright 2016-2025</a>, Texas Instruments Incorporated. All rights reserved. <br>
      <a href="http://www.ti.com/corp/docs/legal/trademark/trademrk.htm">Trademarks</a> | <a href="http://www.ti.com/corp/docs/legal/privacy.shtml">Privacy policy</a> | <a href="http://www.ti.com/corp/docs/legal/termsofuse.shtml">Terms of use</a> | <a href="http://www.ti.com/lsds/ti/legal/termsofsale.page">Terms of sale</a>

    </p>
  </div> 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'11.00.04',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

    <script src="http://www.ti.com/assets/js/headerfooter/analytics.js" type="text/javascript" charset="utf-8"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
        });

      var menuHeight = window.innerHeight;

      var contentOffset = $(".wy-nav-content-wrap").offset();
      var contentHeight = $(".wy-nav-content-wrap").height();
      var contentBottom = contentOffset.top + contentHeight;

      function setNavbarTop() {
          var scrollTop = $(window).scrollTop();
          var maxTop = scrollTop + menuHeight;

          // If past the header
          if (scrollTop > contentOffset.top && maxTop < contentBottom) {
            stickyTop = scrollTop - contentOffset.top;
          } else if (maxTop > contentBottom) {
            stickyTop = scrollTop - contentOffset.top - (maxTop - contentBottom);
          } else {
            stickyTop = 0;
          }

          $(".wy-nav-side").css("top", stickyTop);
      }

      $(document).ready(function() {
        setNavbarTop();
        $(window).scroll(function () {
          setNavbarTop();
        });

        $('body').on("mousewheel", function () {
            // Remove default behavior
            event.preventDefault();
            // Scroll without smoothing
            var wheelDelta = event.wheelDelta;
            var currentScrollPosition = window.pageYOffset;
            window.scrollTo(0, currentScrollPosition - wheelDelta);
        });
      });
  </script>
   

</body>
</html>